// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from foros_msgs:srv/RequestVote.idl
// generated code does not contain a copyright notice
#include "foros_msgs/srv/detail/request_vote__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"

bool
foros_msgs__srv__RequestVote_Request__init(foros_msgs__srv__RequestVote_Request * msg)
{
  if (!msg) {
    return false;
  }
  // term
  // candidate_id
  // last_data_index
  // loat_data_term
  return true;
}

void
foros_msgs__srv__RequestVote_Request__fini(foros_msgs__srv__RequestVote_Request * msg)
{
  if (!msg) {
    return;
  }
  // term
  // candidate_id
  // last_data_index
  // loat_data_term
}

bool
foros_msgs__srv__RequestVote_Request__are_equal(const foros_msgs__srv__RequestVote_Request * lhs, const foros_msgs__srv__RequestVote_Request * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // term
  if (lhs->term != rhs->term) {
    return false;
  }
  // candidate_id
  if (lhs->candidate_id != rhs->candidate_id) {
    return false;
  }
  // last_data_index
  if (lhs->last_data_index != rhs->last_data_index) {
    return false;
  }
  // loat_data_term
  if (lhs->loat_data_term != rhs->loat_data_term) {
    return false;
  }
  return true;
}

bool
foros_msgs__srv__RequestVote_Request__copy(
  const foros_msgs__srv__RequestVote_Request * input,
  foros_msgs__srv__RequestVote_Request * output)
{
  if (!input || !output) {
    return false;
  }
  // term
  output->term = input->term;
  // candidate_id
  output->candidate_id = input->candidate_id;
  // last_data_index
  output->last_data_index = input->last_data_index;
  // loat_data_term
  output->loat_data_term = input->loat_data_term;
  return true;
}

foros_msgs__srv__RequestVote_Request *
foros_msgs__srv__RequestVote_Request__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  foros_msgs__srv__RequestVote_Request * msg = (foros_msgs__srv__RequestVote_Request *)allocator.allocate(sizeof(foros_msgs__srv__RequestVote_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(foros_msgs__srv__RequestVote_Request));
  bool success = foros_msgs__srv__RequestVote_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
foros_msgs__srv__RequestVote_Request__destroy(foros_msgs__srv__RequestVote_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    foros_msgs__srv__RequestVote_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
foros_msgs__srv__RequestVote_Request__Sequence__init(foros_msgs__srv__RequestVote_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  foros_msgs__srv__RequestVote_Request * data = NULL;

  if (size) {
    data = (foros_msgs__srv__RequestVote_Request *)allocator.zero_allocate(size, sizeof(foros_msgs__srv__RequestVote_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = foros_msgs__srv__RequestVote_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        foros_msgs__srv__RequestVote_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
foros_msgs__srv__RequestVote_Request__Sequence__fini(foros_msgs__srv__RequestVote_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      foros_msgs__srv__RequestVote_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

foros_msgs__srv__RequestVote_Request__Sequence *
foros_msgs__srv__RequestVote_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  foros_msgs__srv__RequestVote_Request__Sequence * array = (foros_msgs__srv__RequestVote_Request__Sequence *)allocator.allocate(sizeof(foros_msgs__srv__RequestVote_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = foros_msgs__srv__RequestVote_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
foros_msgs__srv__RequestVote_Request__Sequence__destroy(foros_msgs__srv__RequestVote_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    foros_msgs__srv__RequestVote_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
foros_msgs__srv__RequestVote_Request__Sequence__are_equal(const foros_msgs__srv__RequestVote_Request__Sequence * lhs, const foros_msgs__srv__RequestVote_Request__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!foros_msgs__srv__RequestVote_Request__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
foros_msgs__srv__RequestVote_Request__Sequence__copy(
  const foros_msgs__srv__RequestVote_Request__Sequence * input,
  foros_msgs__srv__RequestVote_Request__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(foros_msgs__srv__RequestVote_Request);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    foros_msgs__srv__RequestVote_Request * data =
      (foros_msgs__srv__RequestVote_Request *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!foros_msgs__srv__RequestVote_Request__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          foros_msgs__srv__RequestVote_Request__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!foros_msgs__srv__RequestVote_Request__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


bool
foros_msgs__srv__RequestVote_Response__init(foros_msgs__srv__RequestVote_Response * msg)
{
  if (!msg) {
    return false;
  }
  // term
  // vote_granted
  return true;
}

void
foros_msgs__srv__RequestVote_Response__fini(foros_msgs__srv__RequestVote_Response * msg)
{
  if (!msg) {
    return;
  }
  // term
  // vote_granted
}

bool
foros_msgs__srv__RequestVote_Response__are_equal(const foros_msgs__srv__RequestVote_Response * lhs, const foros_msgs__srv__RequestVote_Response * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // term
  if (lhs->term != rhs->term) {
    return false;
  }
  // vote_granted
  if (lhs->vote_granted != rhs->vote_granted) {
    return false;
  }
  return true;
}

bool
foros_msgs__srv__RequestVote_Response__copy(
  const foros_msgs__srv__RequestVote_Response * input,
  foros_msgs__srv__RequestVote_Response * output)
{
  if (!input || !output) {
    return false;
  }
  // term
  output->term = input->term;
  // vote_granted
  output->vote_granted = input->vote_granted;
  return true;
}

foros_msgs__srv__RequestVote_Response *
foros_msgs__srv__RequestVote_Response__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  foros_msgs__srv__RequestVote_Response * msg = (foros_msgs__srv__RequestVote_Response *)allocator.allocate(sizeof(foros_msgs__srv__RequestVote_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(foros_msgs__srv__RequestVote_Response));
  bool success = foros_msgs__srv__RequestVote_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
foros_msgs__srv__RequestVote_Response__destroy(foros_msgs__srv__RequestVote_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    foros_msgs__srv__RequestVote_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
foros_msgs__srv__RequestVote_Response__Sequence__init(foros_msgs__srv__RequestVote_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  foros_msgs__srv__RequestVote_Response * data = NULL;

  if (size) {
    data = (foros_msgs__srv__RequestVote_Response *)allocator.zero_allocate(size, sizeof(foros_msgs__srv__RequestVote_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = foros_msgs__srv__RequestVote_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        foros_msgs__srv__RequestVote_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
foros_msgs__srv__RequestVote_Response__Sequence__fini(foros_msgs__srv__RequestVote_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      foros_msgs__srv__RequestVote_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

foros_msgs__srv__RequestVote_Response__Sequence *
foros_msgs__srv__RequestVote_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  foros_msgs__srv__RequestVote_Response__Sequence * array = (foros_msgs__srv__RequestVote_Response__Sequence *)allocator.allocate(sizeof(foros_msgs__srv__RequestVote_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = foros_msgs__srv__RequestVote_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
foros_msgs__srv__RequestVote_Response__Sequence__destroy(foros_msgs__srv__RequestVote_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    foros_msgs__srv__RequestVote_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
foros_msgs__srv__RequestVote_Response__Sequence__are_equal(const foros_msgs__srv__RequestVote_Response__Sequence * lhs, const foros_msgs__srv__RequestVote_Response__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!foros_msgs__srv__RequestVote_Response__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
foros_msgs__srv__RequestVote_Response__Sequence__copy(
  const foros_msgs__srv__RequestVote_Response__Sequence * input,
  foros_msgs__srv__RequestVote_Response__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(foros_msgs__srv__RequestVote_Response);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    foros_msgs__srv__RequestVote_Response * data =
      (foros_msgs__srv__RequestVote_Response *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!foros_msgs__srv__RequestVote_Response__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          foros_msgs__srv__RequestVote_Response__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!foros_msgs__srv__RequestVote_Response__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
