// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from foros_msgs:srv/RequestVote.idl
// generated code does not contain a copyright notice

#ifndef FOROS_MSGS__SRV__DETAIL__REQUEST_VOTE__STRUCT_H_
#define FOROS_MSGS__SRV__DETAIL__REQUEST_VOTE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Struct defined in srv/RequestVote in the package foros_msgs.
typedef struct foros_msgs__srv__RequestVote_Request
{
  /// candidate's term
  uint64_t term;
  /// candidate requesting vote
  uint32_t candidate_id;
  /// index of candidate's last data entry
  uint64_t last_data_index;
  /// term of candidate's last data entry
  uint64_t loat_data_term;
} foros_msgs__srv__RequestVote_Request;

// Struct for a sequence of foros_msgs__srv__RequestVote_Request.
typedef struct foros_msgs__srv__RequestVote_Request__Sequence
{
  foros_msgs__srv__RequestVote_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} foros_msgs__srv__RequestVote_Request__Sequence;


// Constants defined in the message

/// Struct defined in srv/RequestVote in the package foros_msgs.
typedef struct foros_msgs__srv__RequestVote_Response
{
  /// current term, for candidate to update itself
  uint64_t term;
  /// true means candidate received vote
  bool vote_granted;
} foros_msgs__srv__RequestVote_Response;

// Struct for a sequence of foros_msgs__srv__RequestVote_Response.
typedef struct foros_msgs__srv__RequestVote_Response__Sequence
{
  foros_msgs__srv__RequestVote_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} foros_msgs__srv__RequestVote_Response__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // FOROS_MSGS__SRV__DETAIL__REQUEST_VOTE__STRUCT_H_
